package cc.fascinated.model.score.impl.scoresaber;

import cc.fascinated.model.leaderboard.Leaderboard;
import cc.fascinated.model.score.DeviceInformation;
import cc.fascinated.model.user.UserDTO;
import cc.fascinated.platform.Platform;
import lombok.Getter;

import java.util.Date;

/**
 * @author Fascinated (fascinated7)
 */
@Getter
public class ScoreSaberScoreResponse extends ScoreSaberScore {
    /**
     * The user that set the score.
     */
    private final UserDTO user;

    /**
     * The leaderboard the score was set on.
     */
    private final Leaderboard leaderboard;

    public ScoreSaberScoreResponse(long id, String playerId, Platform.Platforms platform, String platformScoreId, String leaderboardId, int rank,
                                   double accuracy, double pp, int score, String[] modifiers, int misses, int badCuts, DeviceInformation deviceInformation,
                                   Date timestamp, double weight, double multiplier, int maxCombo, UserDTO user, Leaderboard leaderboard) {
        super(id, playerId, platform, platformScoreId, leaderboardId, rank, accuracy, pp, score, modifiers, misses, badCuts,
                deviceInformation, timestamp, weight, multiplier, maxCombo);
        this.user = user;
        this.leaderboard = leaderboard;
    }

    /**
     * Creates a new score saber score response.
     *
     * @param score the score to create the response from
     * @param user the user that set the score
     * @param leaderboard the leaderboard the score was set on
     * @return the score saber score response
     */
    public static ScoreSaberScoreResponse fromScore(ScoreSaberScore score, UserDTO user, Leaderboard leaderboard) {
        return new ScoreSaberScoreResponse(score.getId(), score.getPlayerId(), score.getPlatform(), score.getPlatformScoreId(), score.getLeaderboardId(),
                score.getRank(), score.getAccuracy(), score.getPp(), score.getScore(), score.getModifiers(), score.getMisses(), score.getBadCuts(),
                score.getDeviceInformation(), score.getTimestamp(), score.getWeight(), score.getMultiplier(), score.getMaxCombo(), user, leaderboard);
    }
}
